#include <stdio.h>
#include <stdlib.h>
#include <jmp-config.h>
#include <jmp.h>
#include <method.h>
#include <jthread.h>
#include <cls.h>

/** dump a method to the given file */
void dump_method_row (method* m, FILE* f) {
    methodtime* mt;
    cls* c = method_get_owner (m);
    mt = method_get_time_used (m);
    fprintf (f, "%s\t%s\t%ld.%06ld\t%ld\t%ld.%06ld\n", 
	     cls_get_name (c),
	     method_get_method_jmpname (m),
	     mt->tv_sec,
	     mt->tv_usec,
	     method_get_calls (m),
	     mt->tv_sec_hold,
	     mt->tv_usec_hold);	     
}

void dump_jthread_row (jthread* t, FILE* f) {
    method* mp = NULL;
    timerstack* s;
    int i;

    fprintf (f, "%p\t%s\t%s\t%s\t\n",
	     t->env_id,
	     jthread_get_thread_name(t),
	     jthread_get_group_name(t),
	     jthread_get_parent_name(t));
    
    s = get_timerstack ((JNIEnv*)t->env_id);
    for (i = s->top - 1; i >= 0; i--) {
	methodtime* mt = s->times + i;
	mp = get_method (mt->method_id);
	if (mp != NULL) 
	    fprintf (f, "\t%s\t%s\n",
		     cls_get_name (mp->owner),
		     method_get_method_jmpname (mp));
	else 
	    fprintf (f, "\t?\t?\n" );	    	
    }
}

/** Dump a class to the given file. */
void dump_class_row (cls* c, FILE* f) {
    fprintf (f, "%s\t%ld\t%ld\t%ld\t%ld\n", 
	     cls_get_name (c),
	     cls_get_instances (c),
	     cls_get_max_instances (c),
	     cls_get_size (c),
	     cls_get_total_gc (c));    
}
