#include <stdlib.h>
#include <string.h>
#include <filter.h>
#include <jmp-config.h>

/* The filter string for class names */
static char* classfilter;
static size_t len;
/*static GString *classfilter;*/

/* One of FILTER_MATCH_ALL, FILTER_EXACT, FILTER_PACKAGE or FILTER_RECURSIVE */
static int filter_mode = FILTER_MATCH_ALL;

int filter_class_name (const char *name)
{
    int r;

    if (filter_mode == FILTER_MATCH_ALL || classfilter == NULL)
	return 1;

    if (filter_mode == FILTER_MATCH_CLASS)
	return !strcmp (name, classfilter);

    if (filter_mode == FILTER_MATCH_RECURSIVE)
	return !strncmp(name, classfilter, len);

    /* FILTER_MATCH_PACKAGE */
    r = strncmp (name, classfilter, len);
    if (r)
	return 0;
    else
	return (!index (name + len, '.'));
  
}

/* Set the filter. 
 * @param filtertype one of FILTER_MATCH_*
 * @param filter the string to filter on ("rabbit.proxy").
 */
void filter_set_filter (int filtertype, const char *filter) {
    if (filter == NULL)
	return;
    filter_mode = filtertype;
    if (classfilter)
	free (classfilter);
    classfilter = strdup (filter);
    len = strlen (classfilter);
}

char* get_filter () {
    return classfilter;
}

int get_filter_type () {
    return filter_mode;
}

