#include <jmptime.h>
#if HAVE_SYS_TIME_H
#include <sys/time.h>
#endif


jlong get_time (JVMPI_Interface* jvmpi) {
    jlong tval;
#ifdef HAVE_SYS_TIME_H
    struct timeval tv;
    gettimeofday (&tv, NULL);
    tval = ((jlong)tv.tv_sec) * 1000000000 + ((jlong)tv.tv_usec) * 1000;    
#else
    /* currently there is a bug in the jvm, returns microsec instead of nanosec. */
    /* since this timing is wrong anyway we ignore that problem for now. */
    tval = jvmpi->GetCurrentThreadCpuTime ();
#endif
    return tval;
}
