#include <stdio.h>
#include <stdlib.h>
#include <timerstack.h>

timerstack* timerstack_new (size_t size) {
    timerstack* ts = malloc (sizeof (*ts));
    if (ts == NULL)
	return NULL;
    ts->times = malloc (sizeof (*ts->times) * size);
    if (ts->times == NULL)
	timerstack_free (ts);
    ts->top = 0;
    ts->max = size;
    return ts;
}

void   timerstack_free (timerstack* s) {
    if (s == NULL)
	return;
    free (s->times);
    free (s);
}

/** Expand the given stack. */
void timerstack_expand (timerstack* s) {
    methodtime* ns;
    if (s == NULL)
	return;
    ns = realloc (s->times, sizeof (*s->times) * s->max * 2);
    if (ns) {
	s->times = ns;
	s->max *= 2;
    } else {
	fprintf (stderr, "timerstack_expand: failed to realloc methodtimes.\n");
    }
}
