#ifndef UI_H__
#define UI_H__

#include <hash.h>

enum {
    OCLASS_COLUMN,
    OINSTANCE_COLUMN,
    OINSTANCE_MAX_COLUMN,
    OSIZE_COLUMN,
    OGC_COLUMN,
    OOBJECT_COLUMN,
    ON_COLUMNS
};

enum {
    MCLASS_COLUMN,
    MMETHOD_NAME_COLUMN,
    MSECS_COLUMN,
    MCALLS_COLUMN,
    MSUBS_COLUN,
    MTOTAL_COLUMN,
    MMETHOD_COLUMN,
    MN_COLUMNS
};

/** The thread used to run gtk-main. 
 */
void gtkthread (void* data);

/** Tell the ui system to shut itself down. */
void quit_ui (void);

/** Update the statistics. */
void updateUI (hashtab* cls, hashtab* methods);

/** Return the id of the dump file. */
int dump_data (char* dumpfile, hashtab* cls, hashtab* methods, hashtab* threads);

/** Set the dump timer... */
void set_dump_timer (int dumptimer);

/** Get the current dump timer. */
int get_dump_timer (void);

/** Set the status text... */
void set_status (char* text);

/** Check if we have any ui-handling to do. */
int events_pending (void);

/** Update the ui-toolkit (gtk_main_iteration ()) */
int ui_iteration (void);

#endif /* UI_H__ */
